//+------------------------------------------------------------------+
//|                                                      BBMacd.mq4  |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers    5
#property indicator_color1     Red
#property indicator_color2     Blue
#property indicator_color3     Lime
#property indicator_color4     Magenta
#property indicator_color5     Magenta
#property indicator_width3     1
#property indicator_width4     1
#property indicator_width5     1
#property indicator_level1     0
#property indicator_levelcolor MediumOrchid

//
//
//
//
//

extern string TimeFrame                   = "current time frame";
extern int    FastOmaPeriod               = 13;
extern double FastOmaSpeed                = -1.0;
extern bool   FastOmaAdaptive             = true;
extern int    FastOmaPrice                = PRICE_CLOSE;
extern int    SlowOmaPeriod               = 13;
extern double SlowOmaSpeed                = -1.0;
extern bool   SlowOmaAdaptive             = false;
extern int    SlowOmaPrice                = PRICE_CLOSE;
extern int    Length                      = 10;
extern double StDv                        = 1.0;  
extern bool   Interpolate                 = true;
extern bool   drawDots                    = true;

extern bool   alertsOn                    = true;
extern bool   alertsOnSlope               = true;
extern bool   alertsOnBandBreakout        = true;
extern bool   alertsOnCurrent             = true;
extern bool   alertsMessage               = true;
extern bool   alertsSound                 = false;
extern bool   alertsNotify                = false;
extern bool   alertsEmail                 = false;

extern bool   arrowsVisible               = true;
extern string arrowsIdentifier            = "bbmacd Arrows1";
extern double arrowsDisplacement          = 1.0;

extern bool   arrowsOnSlope               = false;
extern color  arrowsOnSlopeUpColor        = LimeGreen;
extern color  arrowsOnSlopeDnColor        = Red;
extern int    arrowsOnSlopeUpCode         = 241;
extern int    arrowsOnSlopeDnCode         = 242;
extern int    arrowsOnSlopeUpSize         = 1;
extern int    arrowsOnSlopeDnSize         = 1;

extern bool   arrowsOnBandBreakout        = true;
extern color  arrowsOnBandBreakoutUpColor = LimeGreen;
extern color  arrowsOnBandBreakoutDnColor = Red;
extern int    arrowsOnBandBreakoutUpCode  = 119;
extern int    arrowsOnBandBreakoutDnCode  = 119;
extern int    arrowsOnBandBreakoutUpSize  = 3;
extern int    arrowsOnBandBreakoutDnSize  = 3;

extern int    xDistance                   = 10;
extern int    yDistance                   = 10;
extern color  LabelsColorUp               = Green;
extern color  LabelsColorNeutral          = DimGray;
extern color  LabelsColorDown             = Crimson;    


//
//
//
//
//

double buffer1[];
double buffer2[];
double bbMacd[];
double buffer4[];
double buffer5[];
double buffer6[];
double slope[];
double trend[];

//
//
//
//
//

int    timeFrame;
string shortName;
string indicatorFileName;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,buffer1);
   SetIndexBuffer(1,buffer2);
   SetIndexBuffer(2,bbMacd);                               
   SetIndexBuffer(3,buffer4);
   SetIndexBuffer(4,buffer5);
   SetIndexBuffer(5,buffer6);
   SetIndexBuffer(6,slope);
   SetIndexBuffer(7,trend);
   
      if (drawDots) 
      {
         SetIndexStyle(2, DRAW_ARROW,0); SetIndexArrow(2, 159);
         SetIndexStyle(3, DRAW_ARROW,0); SetIndexArrow(3, 159);
         SetIndexStyle(4, DRAW_NONE);
      }
      else
      {
         SetIndexStyle(2, DRAW_LINE);
         SetIndexStyle(3, DRAW_LINE);
         SetIndexStyle(4, DRAW_LINE);
      }

   
      //
      //
      //
      //
      //
         FastOmaPeriod     = MathMax(FastOmaPeriod,1);
	      FastOmaSpeed      = MathMax(FastOmaSpeed,-1.5);
	      SlowOmaPeriod     = MathMax(SlowOmaPeriod,1);
	      SlowOmaSpeed      = MathMax(SlowOmaSpeed,-1.5);
         Length            = MathMax(Length,1);
         indicatorFileName = WindowExpertName();
         calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
         returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
   IndicatorDigits(5);
   shortName = arrowsIdentifier+": "+timeFrameToString(timeFrame)+" BB OMacd ("+FastOmaPeriod+","+SlowOmaPeriod+","+Length+")";
   IndicatorShortName(shortName);
      SetIndexLabel(0, "Upperband");
      SetIndexLabel(1, "Lowerband");  
      SetIndexLabel(2, "BB Macd");
      SetIndexLabel(3, NULL);
      SetIndexLabel(4, NULL);     
return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int deinit()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
   return(0);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   int limit,i,counted_bars = IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
       limit = MathMin(Bars - counted_bars,Bars-1);
       if (returnBars) { buffer1[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
      if (!drawDots) if (slope[limit]==-1) CleanPoint(limit,buffer4,buffer5);
      double alpha = 2.0 / (Length + 1.0);
      for(i = limit; i >= 0 ; i--)
      {
         bbMacd[i]   = iOma(iMA(NULL,0,1,0,MODE_SMA,FastOmaPrice,i),FastOmaPeriod,FastOmaSpeed,FastOmaAdaptive,i,0)-
                       iOma(iMA(NULL,0,1,0,MODE_SMA,SlowOmaPrice,i),SlowOmaPeriod,SlowOmaSpeed,SlowOmaAdaptive,i,1);
         buffer6[i]  = buffer6[i+1] + alpha*(bbMacd[i] - buffer6[i+1]); 
         double sDev = iDeviation(bbMacd, buffer6[i],Length, i);  
         buffer1[i]  = buffer6[i] + (StDv * sDev);
         buffer2[i]  = buffer6[i] - (StDv * sDev);    
         buffer4[i]  = EMPTY_VALUE;  
         buffer5[i]  = EMPTY_VALUE; 
       
         //
         //        
         //
         //
         // 
         
         slope[i] = slope[i+1];
         trend[i] = trend[i+1];
         if (bbMacd[i] > bbMacd[i+1]) slope[i] =  1; 
         if (bbMacd[i] < bbMacd[i+1]) slope[i] = -1; 
         if (bbMacd[i] > buffer1[i])  trend[i] =  1; 
         if (bbMacd[i] < buffer2[i])  trend[i] = -1; 
            
         if (slope[i]==-1) if (drawDots)     buffer4[i] = bbMacd[i];
                           else  PlotPoint(i,buffer4,buffer5,bbMacd);
         manageArrow(i);   
      }
   manageLabels();
   manageAlerts();   
   return(0);
   }
       
   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   if (!drawDots) if (slope[limit]==-1) CleanPoint(limit,buffer4,buffer5);
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         buffer1[i]= iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastOmaPeriod,FastOmaSpeed,FastOmaAdaptive,FastOmaPrice,SlowOmaPeriod,SlowOmaSpeed,SlowOmaAdaptive,SlowOmaPrice,Length,StDv,0,y);
         buffer2[i]= iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastOmaPeriod,FastOmaSpeed,FastOmaAdaptive,FastOmaPrice,SlowOmaPeriod,SlowOmaSpeed,SlowOmaAdaptive,SlowOmaPrice,Length,StDv,1,y);
         bbMacd[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastOmaPeriod,FastOmaSpeed,FastOmaAdaptive,FastOmaPrice,SlowOmaPeriod,SlowOmaSpeed,SlowOmaAdaptive,SlowOmaPrice,Length,StDv,2,y);
         buffer4[i]= EMPTY_VALUE;
         buffer5[i]= EMPTY_VALUE;
         slope[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastOmaPeriod,FastOmaSpeed,FastOmaAdaptive,FastOmaPrice,SlowOmaPeriod,SlowOmaSpeed,SlowOmaAdaptive,SlowOmaPrice,Length,StDv,6,y);
         trend[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastOmaPeriod,FastOmaSpeed,FastOmaAdaptive,FastOmaPrice,SlowOmaPeriod,SlowOmaSpeed,SlowOmaAdaptive,SlowOmaPrice,Length,StDv,7,y);
         
         if (drawDots && slope[i]==-1) buffer4[i] = bbMacd[i];   
         manageArrow(i);   
         
         //
         //
         //
         //
         //
      
         if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(int k = 1; k < n; k++)
            {
               bbMacd[i+k]  = bbMacd[i]  + (bbMacd[i+n] - bbMacd[i])  * k/n;
               buffer1[i+k] = buffer1[i] + (buffer1[i+n]- buffer1[i]) * k/n;
               buffer2[i+k] = buffer2[i] + (buffer2[i+n]- buffer2[i]) * k/n;
               if (buffer4[i+k] != EMPTY_VALUE) buffer4[i+k] = bbMacd[i+k];
            }               
   }
   if (!drawDots) for (i=limit;i>=0;i--) if (slope[i]==-1) PlotPoint(i,buffer4,buffer5,bbMacd);
   manageLabels();
   manageAlerts();
return(0);
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

double workOma[][14];
#define F01 0
#define F02 1
#define F03 2
#define F04 3
#define F05 4
#define F06 5
#define prc 6

//
//
//
//
//

double iOma(double price, double averagePeriod, double constant, bool adaptive, int r, int s=0)
{
   if (averagePeriod <=1) return(price);
   if (ArrayRange(workOma,0) != Bars) ArrayResize(workOma,Bars); r=Bars-r-1; s *=7;
   if (r<=1) 
   {
      for (int i=0; i<6; i++) workOma[r][i  +s] = 0;
                              workOma[r][prc+s] = price;
                              return(price);
   }      
   double f01=workOma[r-1][F01+s];  double f02=workOma[r-1][F02+s];
   double f03=workOma[r-1][F03+s];  double f04=workOma[r-1][F04+s];
   double f05=workOma[r-1][F05+s];  double f06=workOma[r-1][F06+s];

   //
   //
   //
   //
   //

      if (adaptive && (averagePeriod > 1))
      {
         double minPeriod = MathMin(averagePeriod,r)/2.0;
         double maxPeriod = MathMin(minPeriod*5.0,r);
         int    endPeriod = (int)MathCeil(maxPeriod);
         double signal    = MathAbs((price-workOma[r-endPeriod][prc+s]));
         double noise     = 0.00000000001;

            for(i=1; i<endPeriod; i++) noise=noise+MathAbs(price-workOma[r-i][prc+s]);

         averagePeriod = ((signal/noise)*(maxPeriod-minPeriod))+minPeriod;
      }
      
      //
      //
      //
      //
      //
      
      double Kg = (2.0+constant)/(1.0+constant+averagePeriod);
      double Hg = 1.0-Kg;

      f01 = Kg * price + Hg * f01; f02 = Kg * f01 + Hg * f02; double v01 = 1.5 * f01 - 0.5 * f02;
      f03 = Kg * v01   + Hg * f03; f04 = Kg * f03 + Hg * f04; double v02 = 1.5 * f03 - 0.5 * f04;
      f05 = Kg * v02   + Hg * f05; f06 = Kg * f05 + Hg * f06; double v03 = 1.5 * f05 - 0.5 * f06;

   //
   //
   //
   //
   //

   workOma[r][F01+s] = f01;  workOma[r][F02+s] = f02;
   workOma[r][F03+s] = f03;  workOma[r][F04+s] = f04;
   workOma[r][F05+s] = f05;  workOma[r][F06+s] = f06;
   workOma[r][prc+s] = price;
   return(v03);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double iDeviation(double& array[],double dMA, int period,int shift)
{
   double dSum = 0.00;
   int    i;

   for(i=0; i<period; i++) dSum += (array[shift+i]-dMA)*(array[shift+i]-dMA);
   
   return(MathSqrt(dSum/period));
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i]   = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M10","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,10,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageLabels()
{
   if (calculateValue) return;

   int window = WindowFind(shortName);
   color theColor = LabelsColorNeutral;
      if (bbMacd[0]>buffer1[0]) theColor = LabelsColorUp;
      if (bbMacd[0]<buffer2[0]) theColor = LabelsColorDown;

   //
   //
   //
   //
   //
      
   string name = arrowsIdentifier+":"+"label_Lowerband";
         if(ObjectFind (name) == -1)
            ObjectCreate(name, OBJ_LABEL, window, 0, 0);
               ObjectSet(name, OBJPROP_XDISTANCE, xDistance);
               ObjectSet(name, OBJPROP_YDISTANCE, yDistance+28);
               ObjectSet(name, OBJPROP_CORNER, 1);
               ObjectSetText(name,"Lower Band : " + DoubleToStr(buffer2[0],5), 10, "Arial Black", LabelsColorNeutral);

      name = arrowsIdentifier+":"+"label_BB Macd";
         if(ObjectFind (name) == -1)
            ObjectCreate(name, OBJ_LABEL, window, 0, 0);
               ObjectSet(name, OBJPROP_XDISTANCE, xDistance);
               ObjectSet(name, OBJPROP_YDISTANCE, yDistance+14);
               ObjectSet(name, OBJPROP_CORNER, 1);
               ObjectSetText(name,"BB Macd : " + DoubleToStr(bbMacd[0],5), 10, "Arial Black", theColor);

      name = arrowsIdentifier+":"+"label_Upperband";
         if(ObjectFind (name) == -1)
            ObjectCreate(name, OBJ_LABEL, window, 0, 0);
               ObjectSet(name, OBJPROP_XDISTANCE, xDistance);
               ObjectSet(name, OBJPROP_YDISTANCE, yDistance);
               ObjectSet(name, OBJPROP_CORNER, 1);
               ObjectSetText(name,"Upper Band : " + DoubleToStr(buffer1[0],5), 10, "Arial Black", LabelsColorNeutral); 
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar)); 

      //
      //
      //
      //
      //
            
      static datetime time1 = 0;
      static string   mess1 = "";
      if (alertsOnSlope && slope[whichBar] != slope[whichBar+1])
      {
         if (slope[whichBar] ==  1) doAlert(time1,mess1,whichBar,"sloping up");
         if (slope[whichBar] == -1) doAlert(time1,mess1,whichBar,"sloping down");
      }
      
      static datetime time2 = 0;
      static string   mess2 = "";
      if (alertsOnBandBreakout && trend[whichBar]!= trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert(time2,mess2,whichBar,"breaking upper band");
         if (trend[whichBar] == -1) doAlert(time2,mess2,whichBar,"breaking lower band");
      }   
   }
}

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," BBMacd ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," BBMacd " +" "+message));
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," BBMacd "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageArrow(int i)
{
   if (!calculateValue && arrowsVisible)
   {
      deleteArrow(Time[i]);
      if (arrowsOnSlope && slope[i] != slope[i+1])
      {
         if (slope[i] == 1) drawArrow(i,arrowsOnSlopeUpColor,arrowsOnSlopeUpCode,arrowsOnSlopeUpSize,false);
         if (slope[i] ==-1) drawArrow(i,arrowsOnSlopeDnColor,arrowsOnSlopeDnCode,arrowsOnSlopeDnSize,true);
      }
      
      if (arrowsOnBandBreakout && trend[i]!= trend[i+1])
      {
         if (trend[i] == 1) drawArrow(i,arrowsOnBandBreakoutUpColor,arrowsOnBandBreakoutUpCode,arrowsOnBandBreakoutUpSize,false);
         if (trend[i] ==-1) drawArrow(i,arrowsOnBandBreakoutDnColor,arrowsOnBandBreakoutDnCode,arrowsOnBandBreakoutDnSize,true);
      }   
   }
}               

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,int theSize,bool up)
{
    string name = arrowsIdentifier+":"+Time[i];
    double gap  = iATR(NULL,0,20,i);   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         ObjectSet(name,OBJPROP_WIDTH,theSize ); 
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsDisplacement * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsDisplacement * gap);
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}

